// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.internal.taglib;

import javax.faces.application.Application;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import org.apache.myfaces.tobago.component.UIFlowLayout;
import org.apache.myfaces.tobago.internal.util.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/** 
 * JSP Tag class, generated from template {@code tag1.2.stg} with class 
 * {@link org.apache.myfaces.tobago.internal.taglib.component.FlowLayoutTagDeclaration}.
 */
public final class FlowLayoutTag extends TobagoELTag {
  private static final Logger LOG = LoggerFactory.getLogger(FlowLayoutTag.class);
  private javax.el.ValueExpression  marginRight;
  private javax.el.ValueExpression  margin;
  private javax.el.ValueExpression  markup;
  private javax.el.ValueExpression  textAlign;
  private javax.el.ValueExpression  marginBottom;
  private javax.el.ValueExpression  marginTop;
  private javax.el.ValueExpression  marginLeft;

  @Override
  public String getComponentType() {
    return UIFlowLayout.COMPONENT_TYPE;
  }
  @Override
  public String getRendererType() {
    return "FlowLayout";
  }

  @Override
  protected void setProperties(final UIComponent uiComponent) {
    super.setProperties(uiComponent);
    final UIFlowLayout component = (UIFlowLayout) uiComponent;
    final FacesContext context = FacesContext.getCurrentInstance();
    final Application application = context.getApplication();
    if (marginRight != null) {
      if (!marginRight.isLiteralText()) {
        component.setValueExpression("marginRight", marginRight);
      } else {
        component.setMarginRight(org.apache.myfaces.tobago.layout.Measure.valueOf(marginRight.getExpressionString()));
      }
    }
    if (margin != null) {
      if (!margin.isLiteralText()) {
        component.setValueExpression("margin", margin);
      } else {
        component.setMargin(org.apache.myfaces.tobago.layout.Measure.valueOf(margin.getExpressionString()));
      }
    }
    if (markup != null) {
      if (!markup.isLiteralText()) {
        component.setValueExpression("markup", markup);
      } else {
        component.setMarkup(org.apache.myfaces.tobago.context.Markup.valueOf(markup.getExpressionString()));
      }
    }
    if (textAlign != null) {
      if (!textAlign.isLiteralText()) {
        component.setValueExpression("textAlign", textAlign);
      } else {
        component.setTextAlign(org.apache.myfaces.tobago.layout.TextAlign.parse(textAlign.getExpressionString()));
      }
    }
    if (marginBottom != null) {
      if (!marginBottom.isLiteralText()) {
        component.setValueExpression("marginBottom", marginBottom);
      } else {
        component.setMarginBottom(org.apache.myfaces.tobago.layout.Measure.valueOf(marginBottom.getExpressionString()));
      }
    }
    if (marginTop != null) {
      if (!marginTop.isLiteralText()) {
        component.setValueExpression("marginTop", marginTop);
      } else {
        component.setMarginTop(org.apache.myfaces.tobago.layout.Measure.valueOf(marginTop.getExpressionString()));
      }
    }
    if (marginLeft != null) {
      if (!marginLeft.isLiteralText()) {
        component.setValueExpression("marginLeft", marginLeft);
      } else {
        component.setMarginLeft(org.apache.myfaces.tobago.layout.Measure.valueOf(marginLeft.getExpressionString()));
      }
    }
  }

  public javax.el.ValueExpression getMarginRight() {
    return marginRight;
  }

  public void setMarginRight(final javax.el.ValueExpression marginRight) {
    this.marginRight = marginRight;
  }

  public javax.el.ValueExpression getMargin() {
    return margin;
  }

  public void setMargin(final javax.el.ValueExpression margin) {
    this.margin = margin;
  }

  public javax.el.ValueExpression getMarkup() {
    return markup;
  }

  public void setMarkup(final javax.el.ValueExpression markup) {
    this.markup = markup;
  }

  public javax.el.ValueExpression getTextAlign() {
    return textAlign;
  }

  public void setTextAlign(final javax.el.ValueExpression textAlign) {
    this.textAlign = textAlign;
  }

  public javax.el.ValueExpression getMarginBottom() {
    return marginBottom;
  }

  public void setMarginBottom(final javax.el.ValueExpression marginBottom) {
    this.marginBottom = marginBottom;
  }

  public javax.el.ValueExpression getMarginTop() {
    return marginTop;
  }

  public void setMarginTop(final javax.el.ValueExpression marginTop) {
    this.marginTop = marginTop;
  }

  public javax.el.ValueExpression getMarginLeft() {
    return marginLeft;
  }

  public void setMarginLeft(final javax.el.ValueExpression marginLeft) {
    this.marginLeft = marginLeft;
  }



  @Override
  public void release() {
    super.release();
    marginRight = null;
    margin = null;
    markup = null;
    textAlign = null;
    marginBottom = null;
    marginTop = null;
    marginLeft = null;
  }
}